#!/bin/bash
#	VTK file will be put in time/ folder
if [ ! -d time ];then
	mkdir time
fi
#	make animation data
for (( i=0; i <= 100; i++  ))
do
	file=`printf "time/ex_animation_%05d.vtk\n" $i`
	echo Creating $file
	echo	$i|gawk '{
	X0=-1.0;Y0=-1.0;Z0=-1.0;nX=101;nY=101;nZ=101;dX=0.02;dY=0.02;dZ=0.02;
	dt=0.05;
	pi=atan2(1.0,1.0)*4;
	bw=0.1;
	t=dt*$1;
	#	ヘッダーを出力
	printf("# vtk DataFile Version 2.0\n");
	printf("This is example Animation made by make-ex_animation.sh. time=%f\n",t);
	printf("ASCII\n");
	printf("DATASET STRUCTURED_POINTS\n");
	printf("DIMENSIONS %d %d %d\n",nX,nY,nZ);
	printf("ORIGIN %f %f %f\n",X0,Y0,Z0);
	printf("SPACING %f %f %f\n",dX,dY,dZ);
	#	スカラー関数 p を定義
	printf("POINT_DATA %d\n",nX*nY*nZ);
	printf("SCALARS p float\n");
	printf("LOOKUP_TABLE default\n");
	for(k=0;k<nZ;k++) for(j=0;j<nY;j++) for(i=0;i<nX;i++) {
		X=X0+i*dX; Y=Y0+j*dY; Z=Z0+k*dZ;
		X*=(1-bw*cos(2*pi*t));
		Y*=(1-bw*1.2*cos(2*pi*t));
		Z*=(1-bw*0.8*cos(2*pi*t));
		p=exp(-X*X-4*Y*Y-2*Z*Z)*cos(0.5*pi*(4*(X+(1+0.2*cos(2*pi*t))*Y)**2+2*(X-(1-0.2*cos(2*pi*t))*Y)**2+Z*Z))**2
		p+=exp(-((X-0.8)**2+(Y-0.8)**2+(Z-0.8)**2)/0.02)*exp(-sin(2*pi*t)**2/0.5);
		p+=0.4*exp(-((X+0.2)**2+(Y+0.5)**2+(Z-0.5)**2)/0.02)*exp(-sin(2*pi*t)**2/0.5);
		printf("%.10f\n",p);
	}
}'	>	$file
done
