#!/bin/bash
#	make 2D data
echo|gawk 'BEGIN{
	X0=-1.0;Y0=-1.0;nX=21;nY=21;dX=0.1;dY=0.1;
	//
	printf("# vtk DataFile Version 2.0\n");
	printf("This is example 1 made by ex1.sh\n");
	printf("ASCII\n");
	printf("DATASET STRUCTURED_POINTS\n");
	printf("DIMENSIONS %d %d %d\n",nX,nY,1);
	printf("ORIGIN %f %f %f\n",X0,Y0,0.0);
	printf("SPACING %f %f %f\n",dX,dY,1.0);
	//	make Data
	printf("POINT_DATA %d\n",nX*nY);
	printf("VECTORS U float\n");
}
{
}
END{
	#	流れ関数　F=(1-X)(1+X)(1-Y)(1+Y)とすると
	#		  U=-∂F/∂Y=+2Y(1-X^2)
	#		  V=+∂F/∂X=-2X(1-Y^2)
	for(j=0;j<nY;j++)
	for(i=0;i<nX;i++)
	{
		X=X0+i*dX; Y=Y0+j*dY;
		U=2*Y*(1-X*X);
		V=-2*X*(1-Y*Y);
		printf("%f %f %f \n",U,V,0.0);
	}
}'	>	ex_vector.vtk 
